#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int MOD = 1e9 + 7;
struct par {
    int a, b;
};

vector<int> sum(vector<int> &a, vector<int> &b) {
    vector<int> ans;
    reverse(a.begin(), a.end());
    reverse(b.begin(), b.end());
    while (int(a.size()) < int(b.size())) {
        a.push_back(0);
    }
    while (int(b.size()) < int(a.size())) {
        b.push_back(0);
    }
    reverse(a.begin(), a.end());
    reverse(b.begin(), b.end());
    for (int i = 0; i < int(a.size()); i++) {
        ans.push_back(max(a[i], b[i]));
    }
    return ans;
}

vector<int> multiply(vector<int> &a, vector<int> &b) {
    vector<int> cur;
    for (int i = int(b.size()) - 1; i >= 0; i--) {
        vector<int> len;
        for (int j = 0; j < int(a.size()); j++) {
            len.push_back(min(b[i], a[j]));
        }
        for (int val = 0; val < (b.size() - i - 1); val++) {
            len.push_back(0);
        }
        cur = sum(cur, len);
    }
    return cur;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    string a1, b1;
    cin >> a1 >> b1;
    int n = int(a1.size()), m = int(b1.size());
    vector<int> a(n);
    vector<int> b(m);
    for (int i = 0; i < n; i++) {
        a[i] = int(a1[i]) - 48;
    }
    for (int i = 0; i < m; i++) {
        b[i] = int(b1[i]) - 48;
    }
    vector<int> ans1 = sum(a, b);
    vector<int> ans2 = multiply(a, b);
    int first = 0;
    for (int i = 0; i < int(ans1.size()); i++) {
        if (ans1[i] != 0) {
            first = i;
            break;
        }
    }
    for (int i = first; i < int(ans1.size()); i++) {
        cout << ans1[i];
    }
    cout << " ";
    first = 0;
    for (int i = 0; i < int(ans2.size()); i++) {
        if (ans2[i] != 0) {
            first = i;
            break;
        }
    }
    for (int i = first; i < int(ans2.size()); i++) {
        cout << ans2[i];
    }
}