#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll inf = 1e18;
vector<vector<int>> g;

int n;

void dijkstra(vector<pair<int, ll>> &o1) {
    queue<int> q;
    vector<int> from(n);
    vector<ll> dist(n, inf);
    for (int i = 0; i < int(o1.size()); i++) {
        q.push(o1[i].first);
        from[o1[i].first] = i;
        dist[o1[i].first] = 0;
    }
    while (!q.empty()) {
        auto v = q.front();
        q.pop();
        if (o1[from[v]].second >= dist[v] + 1) {
            for (int to: g[v]) {
                if (dist[to] == dist[v] + 1 && o1[from[to]].second < o1[from[v]].second) {
                    from[to] = from[v];
                    q.push(to);
                }
                if (dist[to] == inf || o1[from[to]].second - dist[to] < o1[from[v]].second - (dist[v] + 1)) {
                    from[to] = from[v];
                    dist[to] = dist[v] + 1;
                    q.push(to);
                }
            }
        }
    }
    vector<int> ans;
    for (int i = 0; i < n; i++) {
        if (dist[i] != inf) {
            ans.push_back(i + 1);
        }
    }
    cout << int(ans.size()) << "\n";
    for (int ma: ans) {
        cout << ma << " ";
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int m, k;
    cin >> n >> m >> k;
    g.resize(n);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        g[u - 1].push_back(v - 1);
        g[v - 1].push_back(u - 1);
    }
    vector<pair<int, ll>> o(k);
    for (int i = 0; i < k; i++) {
        cin >> o[i].first >> o[i].second;
        o[i].first--;
    }
    dijkstra(o);
}