#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int inf = 1e9;


vector<vector<int>> g;
vector<bool> used;
int n;

void bfs(int v, int h) {
    vector<int> d(n, inf);
    queue<int> q;
    q.push(v);
    d[v] = 0;
    while (!q.empty()) {
        v = q.front();
        q.pop();
        for (int u: g[v]) {
            if (d[u] > d[v] + 1) {
                d[u] = d[v] + 1;
                q.push(u);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (d[i] <= h) {
            used[i] = true;
        }
    }
}

bool comp(pair<int, int> o1, pair<int, int> o2) {
    return o1.second > o2.second;
}

signed main() {
    int m, k;
    cin >> n >> m >> k;
    g.resize(n);
    vector<pair<int, int>> o(k);
    for (int i = 0; i < n; i++) {
        all.insert(i);
    }
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        g[u - 1].push_back(v - 1);
        g[v - 1].push_back(u - 1);
    }
    for (int i = 0; i < k; i++) {
        int p, h;
        cin >> p >> h;
        o[i].first = p - 1, o[i].second = h;
    }
    sort(o.begin(), o.end(), comp);
    used.assign(n, false);
    for (int i = 0; i < int(o.size()); i++) {
        bfs(o[i].first, o[i].second);
    }
    vector<int> ans;
    for (int i = 0; i < n; i++) {
        if (used[i]) {
            ans.push_back(i);
        }
    }
    cout << int(ans.size()) << "\n";
    for (int ma: ans) {
        cout << (ma + 1) << " ";
    }
}