#include <bits/stdc++.h>

using namespace std;
using ll = long long;
double pi = M_PI;
const int MOD = 1e9 + 7;
const double eps = 1e-6;
const ll INF = 1e15;

struct Point {
    ll x, y;

    Point(ll _x, ll _y) {
        x = _x, y = _y;
    }

};

struct vec {
    ll x, y;

    vec(ll x1, ll x2, ll y1, ll y2) {
        x = x2 - x1, y = y2 - y1;
    }
};


bool qual(double a, double b) {
    if (abs(a - b) <= eps) {
        return true;
    }
    return false;
}

ll scal(vec o1, vec o2) {
    return o1.x * o2.x + o1.y * o2.y;
}

ll vect(vec o1, vec o2) {
    return o1.x * o2.y - o1.y * o2.x;
}

double len(vec a) {
    return sqrt((a.x) * (a.x) + (a.y) * (a.y));
}

double angle(vec o1, vec o2) {
    return atan2(vect(o1, o2), scal(o1, o2));
}


signed main() {
    int n;
    cin >> n;
    vector<Point> a(n, {-1, -1});
    for (int i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
    }
    cout << fixed << setprecision(9)
         << sqrt((a[0].x - a[1].x) * (a[0].x - a[1].x) + (a[0].y - a[1].y) * (a[0].y - a[1].y));
}