#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll inf = 1e18;
vector<vector<int>> g;

int n;

void dijkstra(vector<pair<int, ll>> &o1) {
    set<pair<ll, int>> q;
    vector<ll> dist(n, -1);
    for (int i = 0; i < int(o1.size()); i++) {
        q.insert({o1[i].second, o1[i].first});
        dist[o1[i].first] = o1[i].second;
    }
    while (!q.empty()) {
        auto [w, v] = *q.rbegin();
        q.erase({w, v});
        if (w - 1 >= 0) {
            for (int to: g[v]) {
                if (dist[to] < w - 1) {
                    dist[to] = w - 1;
                    q.insert({dist[to], to});
                }
            }
        }
    }
    vector<int> ans;
    for (int i = 0; i < n; i++) {
        if (dist[i] != -1) {
            ans.push_back(i + 1);
        }
    }
    cout << int(ans.size()) << "\n";
    for (int ma: ans) {
        cout << ma << " ";
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int m, k;
    cin >> n >> m >> k;
    g.resize(n);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        g[u - 1].push_back(v - 1);
        g[v - 1].push_back(u - 1);
    }
    vector<pair<int, ll>> o(k);
    for (int i = 0; i < k; i++) {
        cin >> o[i].first >> o[i].second;
        o[i].first--;
    }
    dijkstra(o);
}