#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int inf = 1e9;


vector<vector<int>> g;
unordered_set<int> all;
vector<bool> used, can;

void bfs(int v, int h) {
    int v1 = v;
    unordered_map<int, int> d;
    for (int ma: all) {
        d[ma] = inf;
    }
    queue<int> q;
    q.push(v);
    d[v] = 0;
    while (!q.empty()) {
        v = q.front();
        q.pop();
        for (int u: g[v]) {
            if (d[u] > d[v] + 1) {
                d[u] = d[v] + 1;
                q.push(u);
            }
        }
    }
    for (auto [a, b]: d) {
        if (b <= h && (a == v1 || !can[a])) {
            all.erase(a);
            used[a] = true;
        }
    }
}

bool comp(pair<int, int> o1, pair<int, int> o2) {
    return o1.second > o2.second;
}

signed main() {
    int n, m, k;
    cin >> n >> m >> k;
    g.resize(n);
    vector<pair<int, int>> o(k);
    for (int i = 0; i < n; i++) {
        all.insert(i);
    }
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        g[u - 1].push_back(v - 1);
        g[v - 1].push_back(u - 1);
    }
    can.assign(n, false);
    for (int i = 0; i < k; i++) {
        int p, h;
        cin >> p >> h;
        can[p - 1] = true;
        o[i].first = p - 1, o[i].second = h;
    }
    sort(o.begin(), o.end(), comp);
    used.assign(n, false);
    for (int i = 0; i < int(o.size()); i++) {
        bfs(o[i].first, o[i].second);
    }
    vector<int> ans;
    for (int i = 0; i < n; i++) {
        if (used[i]) {
            ans.push_back(i);
        }
    }
    cout << int(ans.size()) << "\n";
    for (int ma: ans) {
        cout << (ma + 1) << " ";
    }
}